import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { GoodsRule, GoodsRuleParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商品规则值(规格)表
 */
export async function pageGoodsRule(params: GoodsRuleParam) {
  const res = await request.get<ApiResult<PageResult<GoodsRule>>>(
    MODULES_API_URL + '/shop/goods-rule/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品规则值(规格)表列表
 */
export async function listGoodsRule(params?: GoodsRuleParam) {
  const res = await request.get<ApiResult<GoodsRule[]>>(
    MODULES_API_URL + '/shop/goods-rule',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品规则值(规格)表
 */
export async function addGoodsRule(data: GoodsRule) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-rule',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品规则值(规格)表
 */
export async function updateGoodsRule(data: GoodsRule) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-rule',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品规则值(规格)表
 */
export async function removeGoodsRule(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-rule/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品规则值(规格)表
 */
export async function removeBatchGoodsRule(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-rule/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商品规则值(规格)表
 */
export async function getGoodsRule(id: number) {
  const res = await request.get<ApiResult<GoodsRule>>(
    MODULES_API_URL + '/shop/goods-rule/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
